VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TestEvent"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


'********************************************************************************
'*  TestEven Name:                                                              *
'*  Date:           Sunday, March 10, 2002                                      *
'*  Author:         The VB Guru                                                 *
'*  Compiler:       Microsoft Visual Basic 6.00 (SP4)                           *
'*  Synop:          This is the class that we want to add to the collection.    *
'*                  Because A collection will not fire events of objects that are*
'*                  In the collection (no way of declaring the class as         *
'*                  WithEvents) we must modify our class to use a "Proxy Class" *
'*                  To do the event firing for us in the Collection Class.  You *
'*                  Will notice that I have added a Property to this class called*
'*                  MyEventClass.  You call methods in the EventClass to fire your*
'*                  Events for you.  Notice that the "Property Set" method is   *
'*                  Passing the instance of EventClass byRef, not by Value      *
'*                  Very Important to remember this                             *
'*                                                                              *
'********************************************************************************


Public Event TestingEvent(MyKey As String)                  'Declare all of your Events and make sure you always pass back a "Key" parameter for every event
                                                            'That you fire. This "Key" Parameter should be the same as the "Key" held in the collection, so the
                                                            'User (developer) knows what element in the collection fired the event.

Private WithEvents MyTimer As TimerLite.clsTimerLite        'I just added a Timer to the Class to that when the timer "goes off" the class will fire an event
Attribute MyTimer.VB_VarHelpID = -1
                                                            'So that we can test the whole thing, You should have the TimerLite.DLL included with the Zip File
                                                            'If not, you will need to return to the VB Guru site and download it from the code section.
                                                            


'local variable(s) to hold property value(s)

Private mvarClassName       As String                       'local copy for the "Key"
    
Private mvarMyEventClass    As EventClass                   'local copy for the Event Handler Class
Public Property Set MyEventClass(ByRef vData As EventClass) 'Note that we are setting the Event Class byRef NOT ByVal
    Set mvarMyEventClass = vData
End Property


Public Property Get MyEventClass() As EventClass
   Set MyEventClass = mvarMyEventClass
End Property



Public Property Let MyKey(ByVal vData As String)
    mvarClassName = vData
End Property


Public Property Get MyKey() As String
    MyKey = mvarClassName
End Property



Private Sub Class_Initialize()
                                    'Initialize the timer and get it to fire every ten seconds
    Set MyTimer = New TimerLite.clsTimerLite
    
    With MyTimer
        .Enabled = True
        .Interval = 10000
    End With
End Sub

Private Sub Class_Terminate()
                                    'Clean Up Time
    With MyTimer
        .Enabled = False
        .Interval = 0
    End With
    
    Set MyTimer = Nothing
    
End Sub

Private Sub MyTimer_Timer()
                                        ' The Timer has fired so raise your event
    RaiseEvent TestingEvent(MyKey)      'Incase you do not put this class in a collection
    If Not MyEventClass Is Nothing Then MyEventClass.TestingEvents (MyKey) ' Check to make sure it is not Nothing, this will only happen if you create this class outside of the TestEvents Collection
End Sub
