VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TestEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"TestEvent"
Attribute VB_Ext_KEY = "Member0" ,"TestEvent"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit


'********************************************************************************
'*  Class Name:     TestEvents                                                  *
'*  Date:           Sunday, March 10, 2002                                      *
'*  Author:         The VB Guru                                                 *
'*  Compiler:       Microsoft Visual Basic 6.00  (SP4)                          *
'*  Synop:          This is the glue that wraps the whole thing together.  It   *
'*                  Holds all the classes that you want in the collection, it   *
'*                  Holds an instance of the EventClass, and this class is what *
'*                  Fires any of the events passed to it, up to it's parent     *
'*                  (The thing that made an instance of this class)             *
'*                                                                              *
'*                  I have choosen to place this class in the Standard EXE Level*
'*                  But you could move it to your ActiveX EXE or DLL and get the*
'*                  Same results. It really is up to you where you want to put  *
'*                  it.
'*                                                                              *
'********************************************************************************



Private mCol                    As Collection           'local variable to hold collection

Private WithEvents MyEvents     As TestEXE.EventClass   'Local Var to hold a pointer to the EventClass. This Var will then
Attribute MyEvents.VB_VarHelpID = -1
                                                        'Be passed to each instance of the class that is loaded into the collection
                                                        'This is the Proxy class that will fire the events from the class(s) in the collection
                                                        'Up to this collection so this collection can fire the events to the parent (in this case Form 1)
                                                        'Note: this EventClass is only loaded once and every instance of the class in the collection share
                                                        'The same instance of the event class, very efficient. Because the Event class is in an ActiveX EXE,
                                                        'It also runs on it's own thread and does not share the same thread as the classes in the collection, no thread blocking here.


Public Event TestingEvent(ByVal MyKey As String)        ' Declare all the same events as the classes in the collection that you want to be fired up the the parent (Form 1)

Public Function Add(sKey As String) As TestEXE.TestEvent    ' Always make the Key param not Optional when doing this, that way the class "name" and the key
                                                            ' Are the same, so when the events fire and the class passes it "key" or class name, you can then access that
                                                            ' in the collection.
    'create a new object
    Dim objNewMember As TestEXE.TestEvent
    Set objNewMember = New TestEXE.TestEvent


    'set the properties passed into the method
    objNewMember.MyKey = sKey                       ' Set both the Collection Key for this class and the classes property, "MyKey" to the same thing for easy access to the class in the collection
    mCol.Add objNewMember, sKey
    
    Set objNewMember.MyEventClass = MyEvents        ' Set the Event Handler class to the MyEvents reference


    'return the object created
    Set Add = objNewMember
    Set objNewMember = Nothing


End Function

Public Property Get Item(vntIndexKey As Variant) As TestEvent
Attribute Item.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Item = mCol(vntIndexKey)
End Property



Public Property Get count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    count = mCol.count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mCol.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mCol.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mCol = New Collection
    Set MyEvents = New TestEXE.EventClass           ' Do not forget to Initialize the Event Handler class or else you will be passing a null pointer to the calsses in the collection
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mCol = Nothing
    Set MyEvents = Nothing                              'Clean up time
End Sub

Private Sub MyEvents_TestingEvent(ByVal MyKey As String)
    RaiseEvent TestingEvent(MyKey)                      'When the EventsClass fires an event, just proxy it up to the parent (Form 1)
End Sub
